/***************************************************************************
 *   Copyright (C) 2005 by Rico Rommel   *
 *   ricorommel@web.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <ftw.h>
#include "index.h"
#include <errno.h>
#include <pwd.h>
#include <limits.h>
#include "pathtools.h"
#include <stdlib.h>
#include <unistd.h>


_fileindex *FileIndex;
int indexcount;
struct passwd *user;



_fileindex *CreateFileIndex(struct _userdata *UserData, int usercount, int *filecount) {

/*gibt den Index aller gefundenen Dateien zurück
Parameter: 	UserData	Benutzerdaten
		usercount	Anzahl der Datensätze in Benutzerdatenbank
		filecount	Rückgabewert für Anzahl der Datensätze in FileIndex
*/
	int i;
	char *tmpdir;
	indexcount = 0;

//	FileIndex = calloc(sizeof(_fileindex),1);

	//UID des aktuellen Prozesses sichern
	int procuid = getuid();

	for (i=0; i < usercount; i++) {


		user = getpwuid( (UserData+i)->userid );
		tmpdir = strcat( user->pw_dir, (UserData+i)->dirname);
		
		setfsuid( (UserData+i)->userid );
		nftw(tmpdir, AddFileToIndex, 10, 1);
	}

	setfsuid( procuid );

	*filecount = indexcount;

	_fileindex *newfileindex = calloc(sizeof(_fileindex)*indexcount,1);
	memcpy(newfileindex, FileIndex, sizeof(_fileindex)*indexcount);
	return newfileindex;
}



static int AddFileToIndex(const char *path, struct stat *filestat, int filetyp) {

	
	
	const char *relpath = getrelpath(user->pw_dir, path);

	//Befindet sich Datei schon im Index?
	
	if (strcmp(relpath,"") != 0) {
	int FilePos = FindFileInIndex(relpath, FileIndex, indexcount);


	if (FilePos == -1) {
		
		indexcount++;	
		FileIndex = realloc(FileIndex, indexcount * sizeof(_fileindex));
		(FileIndex+indexcount-1)->userid = user->pw_uid;
		(FileIndex+indexcount-1)->relpath = strdup( relpath);
		(FileIndex+indexcount-1)->modtime = filestat->st_mtime;
		(FileIndex+indexcount-1)->abspath = strdup( path);
		(FileIndex+indexcount-1)->filetyp = filetyp;
		
	}
	else {
		if ((FileIndex+FilePos)->modtime < filestat->st_mtime) {
			(FileIndex+FilePos)->userid = user->pw_uid;
			(FileIndex+FilePos)->relpath = realloc( (FileIndex+FilePos)->relpath, strlen( relpath )+1);
			strcpy((FileIndex+FilePos)->relpath, relpath);
			(FileIndex+FilePos)->modtime = filestat->st_mtime;
			(FileIndex+FilePos)->abspath = realloc( (FileIndex+FilePos)->abspath, strlen( path )+1);
			strcpy((FileIndex+FilePos)->abspath, path);
			(FileIndex+FilePos)->filetyp = filetyp;
			}
		
		}
	}

	return 0;
}


int FindFileInIndex(const char * filename, _fileindex *tmpFileIndex, int maxind) {
	
	/* liefert die Position der Datei filename in Fileindex zurück.
	Mit indexcount muß die Anzahl der Datensätzee in FileIndex übergeben werden.*/
	int i = 0;
	int FileFoundinIndex = -1;
	int n;
	
	while ( ( i < maxind ) && ( FileFoundinIndex == -1 ) )  {
		n = strcmp( (tmpFileIndex + i)->relpath, filename );
		if ( n == 0 ) {
			FileFoundinIndex = i;
			}
		i++;
	}	
	
	return FileFoundinIndex;
}
