/***************************************************************************
 *   Copyright (C) 2005 by Rico Rommel   *
 *   ricorommel@web.de   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <errno.h>
#include "pathtools.h"

extern FILE *output;


const char *getrelpath(char *basedir, const char *abspath) {

/* gibt den relativen Pathnamen von abspath im Bezug auf basedir zurück*/

	return (abspath+strlen(basedir));
}


int CopyFile(const char *srcname, uid_t srcuid, const char*destname, uid_t destuid) {

	//Kopiert die Datei von srcname nach destname

	int procuid = getuid();
	int procgid = getgid();

	struct stat srcstat;
	
	setfsuid( srcuid );
	stat(srcname, &srcstat);

	off_t filesize = srcstat.st_size;
	gid_t srcgid = srcstat.st_gid;

	setfsgid( srcgid );

	int blockcount, rest;
	int maxbuffer = MAXBUFFER * 1024;
	blockcount = filesize / maxbuffer;
	rest = filesize % maxbuffer;

	char * buffer = malloc( maxbuffer );


	FILE *srcfile = fopen(srcname, "rb");
	if (srcfile == NULL) {  fprintf(output, ", Fehler beim öffnen: %s", strerror(errno) ); return 1; };

	setfsuid( destuid);
	FILE *destfile = fopen(destname, "wb");
	if (destfile == NULL) { fprintf(output, ", Fehler beim erstellen: %s", strerror(errno) ); return 1; };


	int i;

	for ( i = 0; i < blockcount; i++ ) {

		setfsuid( srcuid );
		if (fread( buffer, 1, maxbuffer , srcfile ) < maxbuffer) { fprintf(output, ", Fehler beim lesen: %s", strerror(errno) ); fclose(srcfile);return 1; };

		setfsuid( destuid );
		if (fwrite( buffer, 1, maxbuffer, destfile ) < maxbuffer) { fprintf(output, ", Fehler beim schreiben: %s", strerror(errno) ); fclose(destfile); return 1; };

	}

	//Resr kopieren
	setfsuid( srcuid );
	if (fread( buffer, 1, rest , srcfile ) < rest) { fprintf(output, ", Fehler beim lesen: %s", strerror(errno) ); fclose(srcfile); return 1; };

	setfsuid( destuid );
	if (fwrite( buffer, 1, rest, destfile ) < rest) { fprintf(output, ", Fehler beim schreiben: %s", strerror(errno) ); fclose(destfile); return 1; };

			
	setfsuid( srcuid );
	fclose(srcfile);
	setfsuid( destuid );
	fclose(destfile);

	setfsuid( procuid );
	setfsgid( procgid );


	

	free(buffer);
	return 0;
}

